routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\DefaultController;
use App\Http\Controllers\Admin\AdminContentController;
use App\Http\Controllers\Admin\AdminPostController;
use App\Http\Controllers\Admin\AdminCallController;
use App\Http\Controllers\Admin\AdminContentEditableController;

Route::group(['prefix' => 'admin', 'middleware' => ['auth', 'verified', 'can:manager', 'adminPanel']], function () {
    // шлюзы 'admin' и 'manager' описан в app/Providers/AuthServiceProvider.php
    // у админа обязательно есть role 'manager'
    Route::controller(AdminContentController::class)->middleware('can:admin')->group(function () {
        Route::get('/content/trash', 'trash')->name('content.trash');
        Route::put('/content/{id}/restore', 'restore')->whereNumber(['id'])->name('content.restore');
        Route::delete('/content/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('content.remove');
        Route::resource('/content', AdminContentController::class)->parameters(['id' => 'id']);
    });
    // режим contenteditable
    Route::controller(AdminContentEditableController::class)->middleware('can:admin')->group(function () {
        Route::get('/content/{id}/contenteditable', 'index')->whereNumber(['id'])->name('contenteditable');
        Route::post('/content/contenteditable', 'store')->name('contenteditable.store');
    });
    // большая группа роутов
    Route::group(['middleware' => 'can:manager'], function () {
        Route::controller(DefaultController::class)->group(function () {
            Route::get('/', 'index')->name('admin.index');
            Route::post('/cache', 'cache')->name('admin.cache');
            Route::post('/last', 'last')->name('admin.last');
        });

        Route::controller(AdminPostController::class)->group(function () {
            Route::get('/post/trash', 'trash')->name('post.trash');
            Route::put('/post/{id}/restore', 'restore')->whereNumber(['id'])->name('post.restore');
            Route::delete('/post/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('post.remove');
            Route::delete('/post/clearTrash', 'clearTrash')->name('post.clear');
            Route::delete('/post/destroyAll', 'destroyAll')->name('post.destroyAll');
            Route::delete('/post/deleteAll', 'deleteAll')->name('post.deleteAll');
        });

        Route::controller(AdminCallController::class)->group(function () {
            Route::get('/call/trash', 'trash')->name('call.trash');
            Route::put('/call/{id}/restore', 'restore')->whereNumber(['id'])->name('call.restore');
            Route::delete('/call/{id}/destroy', 'destroyForewer')->whereNumber(['id'])->name('call.remove');
            Route::delete('/call/clearTrash', 'clearTrash')->name('call.clear');
            Route::delete('/call/destroyAll', 'destroyAll')->name('call.destroyAll');
            Route::delete('/call/deleteAll', 'deleteAll')->name('call.deleteAll');
        });

        Route::resource('/call', AdminCallController::class)->parameters('id')->whereNumber(['id']);
        Route::resource('/post', AdminPostController::class)->parameters(['id' => 'id'])->whereNumber(['id']);
    });

    Route::get('/phpinfo', function () {
        return phpinfo();
    })->name('admin.phpinfo');
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ContentController;
use App\Http\Controllers\OAuth\OauthController;
use App\Http\Controllers\Admin\CKEditorController;
use App\Http\Controllers\PostsController;
use App\Http\Controllers\CallsController;
use App\Http\Controllers\DesignerController;
use App\Http\Controllers\ChatController;


Route::get('/', [ ContentController::class, 'index' ])->name('content.index');

// Всякие эксперименты
require __DIR__ . '/test.php';

// страницы оптимизации сайтов
require __DIR__ . '/seo.php';

// конструктор чехлов
Route::get('/designer', [ DesignerController::class, 'index' ])->name('designer.index');
Route::post('/constructor', [ DesignerController::class, 'store' ])->name('designer.store');

// ограничения описаны в app/Providers/AppServiceProvider.php
Route::middleware(['throttle:formsLimit'])->group(function () {
    Route::post('/mail', [ PostsController::class, 'store' ])->name('mail.store');
    Route::post('/zvonok', [ CallsController::class, 'store' ])->name('zvonok.store');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

// Oauth2 аутентификация
Route::get('auth/{service}', [OauthController::class, 'redirectToService'])->whereIn('service', ['google', 'github', 'mailru', 'odnoklassniki', 'vkontakte', 'yandex']);
Route::get('auth/{service}/callback', [OauthController::class, 'handleCallback'])->whereIn('service', ['google', 'github', 'mailru', 'odnoklassniki', 'vkontakte', 'yandex']);

require __DIR__.'/ws.php';

require __DIR__.'/admin.php';

require __DIR__.'/auth.php';

// чат где вебсокет сервер на Laravel
Route::get('/chat', [ ContentController::class, 'chat' ])->name('content.chat');
// чат где вебсокет сервер на поднимается отдельно на Node js
Route::get('/nodechat', [ ContentController::class, 'nodechat' ])->name('content.nodechat');
// чат на setTimeout VUE3 MYSQL
Route::get('/vchat', [ ChatController::class, 'index' ])->name('content.chat');
Route::get('/vchat/all', [ ChatController::class, 'all' ]);
Route::get('/vchat/update', [ ChatController::class, 'update' ]);
Route::post('/vchat/store', [ ChatController::class, 'store' ]);
Route::get('/csrf', [ ChatController::class, 'csrf' ]);

// все остальные страницы кроме главной
//Route::get('/{page}', [ ContentController::class, 'page' ])->name('content.page')->whereIn('page', ['sozdanie', 'prodvijenie', 'portfolio', 'parsing', 'bla']);
Route::get('/{page}', [ ContentController::class, 'page' ])->name('content.page');

Route::post('ckeditor/image_upload', [ CKEditorController::class, 'upload' ])->name('upload');

app/Models/Content.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Content extends Model
{
    use HasFactory;
    use SoftDeletes;

    protected $table = 'content';
    protected $guarded = [];

    /*protected $fillable = [
        'page_text',
        'title',
        'title_seo',
        'description',
        'created_at',
        'updated_at',
    ];*/
}

app/Http/Controllers/ContentController.php
<?php

namespace App\Http\Controllers;
use App\Models\Content;
use Illuminate\Support\Facades\Cache;
use App\Events\GetInPortfolioPage;
use Illuminate\Http\Request;

class ContentController extends Controller
{
    public $page; // страница 'sozdanie', 'parsing' и.т.п

    public function index()
    {
        //15552000 - 180 суток
        $data = Cache::remember('index', 15552000, function () {
            return Content::where('page', 'index')->firstOrFail();
        });
//        $data = Content::where('page', 'index')->firstOrFail();
        return response()
            ->view('content.index', compact('data'))
            ->header('Last-Modified', gmdate("D, d M Y H:i:s \G\M\T", $data->updated_at->timestamp))
            ->header('Cache-Control', 'no-cache, no-store, must-revalidate');
    }

    public function page(Request $request, $page)
    {
        $this->page = $page;
        $data = Cache::remember($page, 15552000, function () {
            return Content::where('page', $this->page)->firstOrFail();
        });
//        $data = Content::where('page', $this->page)->firstOrFail();
        // событие проверка. Там отправка сообщения на TG канал
        if($page === 'portfolio'){
            event(new GetInPortfolioPage($request->ip()));
        }
        return response()
            ->view('content.page', compact('data'))
            ->header('Last-Modified', gmdate("D, d M Y H:i:s \G\M\T", $data->updated_at->timestamp))
            ->header('Cache-Control', 'no-cache, no-store, must-revalidate');
    }

    public function nodechat()
    {
        return view('content.nodechat');
    }

    public function chat()
    {
        return view('content.chat');
    }
}

resources/views/admin/content/contenteditable.blade.php
<x-layouts.admin title="Режим contenteditable">
    {{ Breadcrumbs::render('contenteditable', $data) }}
    <div class="c-main">
        <h3>Режим contenteditable страница : {{ $data->page }}</h3>
        Здесь доступно только содержимое страницы. Полное редактирование в <span class="h4"><a
                href="{{ route('content.edit', [$data->id]) }}">в режиме редактора</a></span>
        <div class="contenteditable-block" contenteditable="true">
            {!! $data->page_text !!}
        </div>
        <h3 id="result-block"></h3>
        <button id="content-suuccess" class="btn btn-success">Отправить</button>
        <span id="c_loader">...отправка</span>
        <script>
            let contentBlock = document.querySelector('.contenteditable-block');
            let csrf = document.getElementById('_csrf_token').getAttribute('content');
            let btnS = document.getElementById('content-suuccess');
            let c_loader = document.getElementById('c_loader');
            let resultBlock = document.getElementById('result-block');
            // console.log(csrf);
            btnS.addEventListener('click', () => {
                fetchContent()
            });

            async function fetchContent() {
                c_loader.style.display = 'block';
                let url = '{{ route('contenteditable.store') }}';
                let data = contentBlock.innerHTML;
                // let formData = new FormData();
                let response = await fetch(url, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json;charset=utf-8'
                    },
                    body: JSON.stringify({
                        _token: csrf,
                        id: {{ $data->id }},
                        data: data
                    })
                });
                let result;
                if (!response.ok) {
                    let errText;
                    if (response.status == 422) { // ошибки валидации
                        result = await response.json();
                        let errors = result.errors;
                        // console.log('validate errors');
                        // console.log(errors.data[0]);
                        errText = errors.data[0];
                    } else { // при ошибках 500 или других
                        errText = 'Ошибка cервера! <small>смотри консоль</small>';
                    }
                    resultBlock.innerHTML = `<span style="color:red">${errText}</span>`;
                } else { // 200 oK
                    result = await response.json();
                    console.log('ok');
                    console.log(response);
                    console.log(result);
                    resultBlock.innerHTML = '<span style="color:green">Успешно!</span>';
                }
                c_loader.style.display = 'none';
                setTimeout(() => {
                    resultBlock.innerHTML = '';
                }, 5000)
            }
        </script>
    </div>
</x-layouts.admin>

resources/views/admin/content/create.blade.php
@php
    // показать или нет CKEditor
    $visual = isset($_GET['mode']) && $_GET['mode'] === 'v' ? true : false;
@endphp
@if($visual)
    <script src="{{ asset('js/ckeditor/ckeditor.js') }}"></script>
@endif
<x-layouts.admin title="Создать страницу">
    {{ Breadcrumbs::render('content_create') }}
    <span class="h2">Создание новой страницы</span>&nbsp;&nbsp;<a class="h3" href="{{ route('content.index') }}">все страницы</a>
    <br>
    @if($visual)
        &nbsp;&nbsp;<span class="h3"><a class="h3" href="{{ route('content.create') }}">Текстовый режим</a></span>
    @else
        &nbsp;&nbsp;<span class="h3">Включить <a class="h3"
                                                 href="{{ route('content.create', ['mode' => 'v']) }}">CKEditor</a></span>
    @endif
    <br>
    <br>
    <form method="post" action="{{ route('content.store') }}">
        @csrf
        <div class="form-group">
            <label for="">Алиас/ссылка [page]:</label>
            <input class="form-control @error('page') is-invalid @enderror" type="text" name="page" value="{{ old('page') }}">
            @error('page')<div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Заголовок [title]:</label>
            <input class="form-control @error('title') is-invalid @enderror" type="text" name="title" value="{{ old('title') }}">
            @error('title')<div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Заголовок в тег title [title_seo]:</label>
            <input class="form-control @error('title_seo') is-invalid @enderror" type="text" name="title_seo" value="{{ old('title_seo') }}">
            @error('title_seo')<div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">В тег description [description]:</label>
            <input class="form-control @error('description') is-invalid @enderror" type="text" name="description" value="{{ old('description') }}">
            @error('description')<div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Код страницы [page_text]:</label>
            <textarea class="form-control @error('page_text') is-invalid @enderror" name="page_text" id="summary-ckeditor" cols="30" rows="10">{{ old('page_text') }}</textarea>
            @error('page_text')<div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <button class="btn btn-success" type="submit">Сохранить</button>
        </div>
    </form>
    @if($visual)
    <script>
        CKEDITOR.replace( 'summary-ckeditor', {
            filebrowserUploadUrl: "{{route('upload', ['_token' => csrf_token() ])}}",
            filebrowserUploadMethod: 'form'
        });
    </script>
    @endif
</x-layouts.admin>

resources/views/admin/content/edit.blade.php
@php
    // показать или нет CKEditor
    $visual = isset($_GET['mode']) && $_GET['mode'] === 'v' ? true : false;
@endphp
@if($visual)
    <script src="{{ asset('js/ckeditor/ckeditor.js') }}"></script>
@endif
<x-layouts.admin title="Админка">
    {{ Breadcrumbs::render('content_edit', $page) }}
    <span class="h2">Страница {{ $page->page }}</span>&nbsp;&nbsp;
    <a class="h3" href="{{ route('content.index') }}">все страницы</a>
    <br>
    <span class="h3">Перейти врежим <a class="h3"
                                       href="{{ route('contenteditable', [ $page->id ]) }}">contenteditable</a></span>
    @if($visual)
        &nbsp;&nbsp;<span class="h3"><a class="h3" href="{{ route('content.edit', [ $page->id ]) }}">Текстовый режим</a></span>
    @else
        &nbsp;&nbsp;<span class="h3">Включить <a class="h3"
                                                 href="{{ route('content.edit', [$page->id, 'mode' => 'v']) }}">CKEditor</a></span>
    @endif
    <br>
    <form method="post" action="{{ route('content.update', [ $page->id ]) }}">
        @csrf
        @method('PUT')
        <div class="form-group">
            <label for="">Алиас [page]:</label>
            <input class="form-control @error('page') is-invalid @enderror" type="text" name="page" value="{{$page->page }}">
            @error('page')
            <div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Заголовок [title]:</label>
            <input class="form-control @error('title') is-invalid @enderror" type="text" name="title" value="{{ $page->title }}">
            @error('title')
            <div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Заголовок в тег title [title_seo]:</label>
            <input class="form-control @error('title_seo') is-invalid @enderror" type="text" name="title_seo" value="{{ $page->title_seo }}">
            @error('title_seo')
            <div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">В тег description [description]:</label>
            <input class="form-control @error('description') is-invalid @enderror" type="text" name="description" value="{{ $page->description }}">
            @error('description')
            <div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <label for="">Содержимое страницы [page_text]:</label>
            <textarea rows="10" class="form-control @error('page_text') is-invalid @enderror" name="page_text" id="summary-ckeditor">{{ $page->page_text }}</textarea>
            @error('page_text')
            <div class="text-danger">{{ $message }}</div>@enderror
        </div>
        <div class="form-group">
            <button class="btn btn-success" type="submit">Сохранить</button>
        </div>
    </form>
    @if($visual)
        <script>
            CKEDITOR.replace('summary-ckeditor', {
                filebrowserUploadUrl: "{{route('upload', ['_token' => csrf_token() ])}}",
                filebrowserUploadMethod: 'form'
            });
        </script>
    @endif
</x-layouts.admin>

resources/views/admin/content/index.blade.php
@php
    use Jenssegers\Date\Date;
@endphp
<x-layouts.admin title="Основные страницы | страница {{ $pages->currentPage() }}">
    {{ Breadcrumbs::render('contents') }}
    <br>
    <div class="d-flex">
        <h1>Основные страницы</h1>&nbsp;
        <div>
            <a href="{{ route('content.create') }}" class="btn btn-info">Создать</a>
        </div>
        @if($trashed)
            <div>
                &nbsp;&nbsp;&nbsp;
                <a href="{{ route('content.trash') }}" class="btn btn-warning">Корзина</a>
            </div>
        @endif
    </div>
    @if($count)
    <table class="table-bordered table-hover table-admin">
        <tr>
            <th>id</th>
            <th>page</th>
            <th>title</th>
            <th>дата изменения</th>
            <th>действия</th>
        </tr>
        @foreach($pages as $page)
            <tr>
                <td>{{ $page->id }}</td>
                <td>{{ $page->page }}</td>
                <td>{{ $page->title }}</td>
                @php
                    $date = Date::parse($page->updated_at);
                if($date->isYesterday()){
                    $date = 'вчера в ' . $date->format('H:i');
                }elseif ($date->isToday()){
                    $date = 'сегодня в ' . $date->format('H:i');
                }else{
                    $date = $date->format('j F Y H:i');
                }
                @endphp
                <td>{{ $date }}</td>
                <td>
                    <div class="d-flex">
                        <div class="top-links"><a href="{{ route('content.show', [ $page->id ]) }}"><span
                                    class="fa fa-eye"></span></a></div>
                        <div class="top-links"><a href="{{ route('content.edit', [ $page->id ]) }}"><span
                                    class="fa fa-pen"></span></a></div>
                        <div class="top-links">
                            <form class="delForms" action="{{ route('content.destroy', [ $page->id ]) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button class="delBtns">
                                    <span class="fa fa-trash text-danger"></span>
                                </button>
                            </form>
                        </div>
                    </div>
                </td>
            </tr>
        @endforeach
    </table>
    @else
        <h4>Нет данных</h4>
    @endif
    <br>
    {{ $pages->links('vendor.pagination.bootstrap-4') }}
</x-layouts.admin>

resources/views/admin/content/show.blade.php
<x-layouts.admin title="">
    {{ Breadcrumbs::render('content_show', $page) }}
    <span class="h3">Страница {{ $page->page }}</span>&nbsp;&nbsp;
    <a class="h3" href="{{ route('content.index') }}">все страницы</a>
    <br>
    @include('flash::message')
    <div>
        <a href="{{ route('content.edit', [ $page->id ]) }}" class="btn btn-primary">редактировать</a>
    </div>
    {!! $page->page_text !!}
</x-layouts.admin>

resources/views/admin/content/trash.blade.php
@php
    use Jenssegers\Date\Date;
@endphp
<x-layouts.admin title="Админка">
    {{ Breadcrumbs::render('contents_trashed') }}
    <h1>Корзина</h1>
    <table class="table-bordered table-hover table-admin">
        <tr>
            <th>id</th>
            <th>page</th>
            <th>title</th>
            <th>удалено</th>
            <th>действия</th>
        </tr>
        @foreach($pages as $page)
            <tr>
                <td>{{$page->id }}</td>
                <td>{{ $page->page }}</td>
                <td>{{ $page->title }}</td>
                @php
                    $date = Date::parse($page->deleted_at);
                if($date->isYesterday()){
                    $date = 'вчера в ' . $date->format('H:i');
                }elseif ($date->isToday()){
                    $date = 'сегодня в ' . $date->format('H:i');
                }else{
                    $date = $date->format('j F Y H:i');
                }
                @endphp
                <td>{{ $date }}</td>
                <td>
                    <div class="d-flex">
                        <div>
                            <form class="top-links" action="{{ route('content.restore', [ $page->id ]) }}" method="post">
                                @csrf
                                @method('PUT')
                                <button class="btn btn-info">
                                    восстановить
                                </button>
                            </form>
                        </div>
                        <div>
                            <form class="top-links del-form" action="{{ route('content.remove', [ $page->id ]) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button class="btn btn-danger">
                                    удалить навсегда
                                </button>
                            </form>
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
            </tr>
        @endforeach
    </table>
</x-layouts.admin>